/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the NotificationAssetTranslation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NotificationAssetTranslation{}

// NotificationAssetTranslation struct for NotificationAssetTranslation
type NotificationAssetTranslation struct {
	Language SystemLanguage `json:"language"`
	Subject string `json:"subject"`
	Text string `json:"text"`
	CallToAction *string `json:"call_to_action,omitempty"`
}

// NewNotificationAssetTranslation instantiates a new NotificationAssetTranslation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNotificationAssetTranslation(language SystemLanguage, subject string, text string) *NotificationAssetTranslation {
	this := NotificationAssetTranslation{}
	this.Language = language
	this.Subject = subject
	this.Text = text
	return &this
}

// NewNotificationAssetTranslationWithDefaults instantiates a new NotificationAssetTranslation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNotificationAssetTranslationWithDefaults() *NotificationAssetTranslation {
	this := NotificationAssetTranslation{}
	return &this
}

// GetLanguage returns the Language field value
func (o *NotificationAssetTranslation) GetLanguage() SystemLanguage {
	if o == nil {
		var ret SystemLanguage
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *NotificationAssetTranslation) GetLanguageOk() (*SystemLanguage, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *NotificationAssetTranslation) SetLanguage(v SystemLanguage) {
	o.Language = v
}

// GetSubject returns the Subject field value
func (o *NotificationAssetTranslation) GetSubject() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Subject
}

// GetSubjectOk returns a tuple with the Subject field value
// and a boolean to check if the value has been set.
func (o *NotificationAssetTranslation) GetSubjectOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Subject, true
}

// SetSubject sets field value
func (o *NotificationAssetTranslation) SetSubject(v string) {
	o.Subject = v
}

// GetText returns the Text field value
func (o *NotificationAssetTranslation) GetText() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Text
}

// GetTextOk returns a tuple with the Text field value
// and a boolean to check if the value has been set.
func (o *NotificationAssetTranslation) GetTextOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Text, true
}

// SetText sets field value
func (o *NotificationAssetTranslation) SetText(v string) {
	o.Text = v
}

// GetCallToAction returns the CallToAction field value if set, zero value otherwise.
func (o *NotificationAssetTranslation) GetCallToAction() string {
	if o == nil || IsNil(o.CallToAction) {
		var ret string
		return ret
	}
	return *o.CallToAction
}

// GetCallToActionOk returns a tuple with the CallToAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NotificationAssetTranslation) GetCallToActionOk() (*string, bool) {
	if o == nil || IsNil(o.CallToAction) {
		return nil, false
	}
	return o.CallToAction, true
}

// HasCallToAction returns a boolean if a field has been set.
func (o *NotificationAssetTranslation) HasCallToAction() bool {
	if o != nil && !IsNil(o.CallToAction) {
		return true
	}

	return false
}

// SetCallToAction gets a reference to the given string and assigns it to the CallToAction field.
func (o *NotificationAssetTranslation) SetCallToAction(v string) {
	o.CallToAction = &v
}

func (o NotificationAssetTranslation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NotificationAssetTranslation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["language"] = o.Language
	toSerialize["subject"] = o.Subject
	toSerialize["text"] = o.Text
	if !IsNil(o.CallToAction) {
		toSerialize["call_to_action"] = o.CallToAction
	}
	return toSerialize, nil
}

type NullableNotificationAssetTranslation struct {
	value *NotificationAssetTranslation
	isSet bool
}

func (v NullableNotificationAssetTranslation) Get() *NotificationAssetTranslation {
	return v.value
}

func (v *NullableNotificationAssetTranslation) Set(val *NotificationAssetTranslation) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationAssetTranslation) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationAssetTranslation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationAssetTranslation(val *NotificationAssetTranslation) *NullableNotificationAssetTranslation {
	return &NullableNotificationAssetTranslation{value: val, isSet: true}
}

func (v NullableNotificationAssetTranslation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationAssetTranslation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


